import json


# Data transfer class to combine all necessary User information in one place
class UserProxMoxDTO:
    def __init__(self, email, firstname, lastname, password, username):
        if not isinstance(email, str):
            raise ValueError("email must be a string.")
        self.email = email
        # User not enabled by default
        self.enable = 0
        if not isinstance(firstname, str):
            raise ValueError("firstname must be a string.")
        self.firstname = firstname
        if not isinstance(lastname, str):
            raise ValueError("lastname must be a string.")
        self.lastname = lastname
        # Initial password
        if not isinstance(password, str):
            raise ValueError("password must be a string.")
        self.password = password
        if not isinstance(username, str):
            raise ValueError("username must be a string.")
        self.username = username

    def to_json(self):
        user_data = {
                "email": self.email,
                "enable": self.enable,
                "firstname": self.firstname,
                "lastname": self.lastname,
                "password": self.password,
                "username": self.username
            }
        return json.dumps(user_data)


